{Written by Hunter Beanland. http://www.geocities.com/SiliconValley/Lab/1672/
 Please do not delete these lines!}
program ldir;
uses wincrt,ifpextrn.tpu;

{$I-}
{$M 4500,0,0}

var
 bootrec:array[0..2048] of byte;
 ext,attrib:string[4];
 dot,i,x,a,l,filec,drv:integer;
 filesp:searchrec;
 drive,ap:string[2];
 pa,msg,dpath,mask:string[90];
 time,totsize,z2,pn,pn2:longint;
 tot,rn:real;
 dt:datetime;
 mine,seco,days,mont:string[1];
 c:char;
 er,b:word;

type string20=string[20];

{$I tools.pas}

procedure timeform(files:boolean);
begin
if files then unpacktime(filesp.time,dt);
with dt do
begin
  ap:='a';
  if hour>11 then
  begin
   ap:='p';
   hour:=hour-12;
  end;
  if hour=0 then hour:=12;
  mine:='';
  seco:='';
  mont:='';
  days:='';
  if min<10 then mine:='0';
  if sec<10 then seco:='0';
  if day<10 then days:='0';
  if month<10 then mont:='0';
end;
end;

procedure attribute;
begin
attrib:='....';
with filesp do
begin
 if (1 and attr)=1 then attrib[1]:='R';
 if (2 and attr)=2 then attrib[2]:='H';
 if (4 and attr)=4 then attrib[3]:='S';
 if (8 and attr)=8 then attrib:='V';
 if (16 and attr)=16 then attrib:='DIR';
 if (32 and attr)=32 then attrib[4]:='A';
end;
end;

procedure rule;
begin
 textcolor(14);
 writeln('');
end;


procedure waitsign;
begin
 textcolor(142);
 write('Press a key...');
 c:=readkey;
 write(#13);
 textcolor(14);
 writeln('');
 l:=0;
end;

procedure writeit;
begin
if (l=(hi(windmax))) then waitsign;
l:=l+1;
rn:=filesp.size/x; z2:=filesp.size div x;
if rn>z2 then pn2:=(z2+1)*x
else pn2:=z2*x;
pn:=pn+pn2;
timeform(true);
attribute;
with filesp do
with dt do
begin
 if attrib='V' then
 begin
  filec:=filec-1;
  exit;
 end;

 dot:=pos(#46,name);
 if (dot<>0) and (name<>'.') and (name<>'..') then
 begin
  ext:=copy(name,dot+1,length(name)-dot);
  name:=copy(name,1,dot-1);
  while length(ext)<3 do
   ext:=ext+#32;
 end
 else ext:='   ';
 if lastmode<>mono then
 begin
 textcolor(7);
  if (ext='COM') or (ext='EXE') then textcolor(10);
  if ext='BAT' then textcolor(14);
  if (ext='SYS') or (ext='BIN') then textcolor(1);
  if (ext='DOC') or (ext='TXT') or (ext='ME') then textcolor(6);
  if (ext='ASM') or (ext='C  ') or (ext='PAS') or (ext='BAS') or
     (ext='LSP') or (ext='FOR') then textcolor(13);
  if (ext='LZH') or (ext='ZIP') or (ext='ARJ') or (ext='ZOO')
    or (ext='PAK') or (ext='ARC') then textcolor(9);
  if attrib='DIR' then textcolor(11);
 end;

 write(name,' ':9-length(name),ext);
 if attrib<>'DIR' then write(comma(size):12)
 else
 begin
  write('            ');
  filec:=filec-1;
 end;
 writeln('  ',hour:2,':',mine,min,':',seco,sec,ap,'  ',days,day,'-',mont,month,'-',year:4,'  ',attrib);
end;
end;

procedure findinput;
begin
pa:=paramstr(1);                         {* default *}
dpath:=''; drive:='';
upstr(pa);
mask:=pa;
if mask[2]=':'then                       {* if drv spec, strip it *}
begin
 drv:=ord(mask[1])-65;
 drive:=mask[1]+mask[2];
 delete(mask,1,2);
end
else
begin                                    {* else get drv *}
 reg.ax:=$1900;
 msdos(reg);
 drv:=lo(reg.ax);
 drive:=chr(drv+65)+':';
end;

if pos('.',mask)=0 then                  {* no mask, must be dir *}
begin
 if (copy(mask,length(mask),1)<>'\') and (mask<>'') then dpath:=mask+'\'
 else dpath:=mask;
 mask:='*.*';
 exit;
end;

if pos('\',mask)=0 then                  {* no dir spec, get it *}
begin
 getdir(drv+1,dpath);
 delete(dpath,1,2);
 if dpath<>'\' then dpath:=dpath+'\';
 exit;
end;

for a:=length(mask) downto 1 do          {* seperate dir & mask *}
 if mask[a]='\' then
 begin
  dpath:=copy(mask,1,a);
  if (dpath<>'\') and (copy(dpath,length(dpath),1)<>'\') then dpath:=dpath+'\';
  mask:=copy(mask,a+1,length(mask));
  if mask='' then mask:='*.*';
 end;
end;

label fin,abort,termin;
begin
textcolor(14);
textbackground(0);
msg:='';
totsize:=0;
filec:=0;
l:=5;
dpath:='';
mask:='';
drive:='';
if (paramcount>1) then
begin
 writeln('== LDIR == [Drv\Path\Mask] {No switches}    H.BEANLAND  (C)opyleft 92  v1.1');
 write('     Lists useful info. about drive & directory.');
 goto termin;
end;

cuoff;
findinput;
if dpath='' then
begin
 getdir(drv+1,dpath);
 delete(dpath,1,2);
 if dpath<>'\' then dpath:=dpath+'\';
end;
findfirst(drive+'\*.*',volumeid,filesp);
if length(filesp.name)>8 then delete(filesp.name,9,1);
if doserror=152 then
begin
 msg:='No response';
 goto abort;
end;
if doserror<>0 then filesp.name:='none'+chr($ff);
timeform(true);
attribute;

with dt do
with filesp do
begin
 write(#13' Volume = ',name);
 if name<>'none'+char($ff) then writeln(hour:18-length(name),':',mine,min,':',seco,sec,ap,
  '  ',days,day,'-',mont,month,'-',year:4)
 else writeln;
 gettime(hour,min,sec,b);
 getdate(year,month,day,b);
 timeform(false);
 er:= diskread(drv,0,1,bootrec);
 if er<>0 then
 begin
  msg:='Read error';
  goto abort;
 end;
 writeln(' S/N    = ',hex(cbw(bootrec[$29],bootrec[$2a]),4),'-',hex(cbw(bootrec[$27],bootrec[$28]),4));
 writeln(' Listed at ',hour:17,':',mine,min,':',seco,sec,ap,'  ',days,day,'-',mont,month,'-',year:4);
 writeln(' Path   = ',drive,dpath,mask);
 rule;
end;

with filesp do
with dt do
begin
findfirst(drive+dpath+mask,anyfile,filesp);
pn:=0;
if doserror<>0 then
begin
 if doserror=3 then
 begin
  msg:='Invalid path';
  goto abort;
 end;
 msg:='No files';
 goto fin;
end;
reg.dl:=drv;
reg.ah:=$1c;
msdos(reg);
x:=integer(reg.al*reg.cx);
 writeit;
 while doserror=0 do
 begin
  filec:=filec+1;
  totsize:=totsize+size;
  findnext(filesp);
  if doserror=0 then writeit;
 end;
fin:
textcolor(12);
if msg<>'' then writeln(#10,msg);
if (l>(hi(windmax)-3)) then begin waitsign; gotoxy(1,wherey-1); end;
rule;
write(' Used:  ',filec,' File');
if filec<>1 then write('s');
writeln(' totals ',comma(totsize),' (',comma(pn),') Bytes');
time:=diskfree(drv+1);
totsize:=disksize(drv+1);
if time<0 then time:=0;
if totsize<0 then totsize:=0;
write(' Free:  ',comma(time),' Bytes of ',totsize/1000000:0:2,' Meg (');
tot:=((time / totsize)*100);
writeln(tot:0:1,'%)');
goto termin;

abort:
write(#10,'LDIR ERROR: ');
textcolor(140);
writeln(msg,' ',pa,length(pa));

termin:
textcolor(7); write(#32);
cuon;
end;
end.